#define	GDCS	0xa0
#define	GDCM	0xa2
#define	GDCP	0xa0
#define	GDCD	0xa2

#define	BLUE	0x4000
#define RED	0x8000
#define GREEN	0xc000

#define	g_start() command(0x0d)
#define g_stop()  command(0x0c)
#define vecte()   command(0x6c)
#define texte()   command(0x68)

ginit()
{
	static int pall_a[8] = {0, 1, 2, 3, 4, 5, 6, 7};
	
	gscreen(0, 0, 3);
	pallet(pall_a);
	lntype(0xffff);
	g_start();
}

gscreen(dis, acc, vram)
int	dis, acc, vram;
{
	select(dis, acc);
	outp(0x68, 2); outp(0x68, 8);
	if(vram == 3) csrform( 0 ); else csrform( 1 );
	switch( vram ) {
		case 1: scroll(   0, 400, 0, 0); break;
		case 2: scroll(8000, 400, 0, 0); break;
		case 3: scroll(   0, 400, 0, 0); break;
	}
}

gcls()
{
	csrw(BLUE , 0, 0, 1); vw_dot(0x3fff); mask(0xffff); write( 0 );
	csrw(RED  , 0, 0, 1); vw_dot(0x3fff); mask(0xffff); write( 0 );
	csrw(GREEN, 0, 0, 1); vw_dot(0x3fff); mask(0xffff); write( 0 );
}

gpset(plane, x, y)
int	plane, x, y;
{
	csrw(plane, x, y, 0); vecte();
}

gline(plane, x1, y1, x2, y2)
int	plane, x1, y1, x2, y2;
{
	int	i, dx, dy, adx, ady, dir;

	csrw(plane, x1, y1, 0);
	dx = x2 - x1; dy = y2 - y1;
	adx = (dx >= 0)? dx: -dx;
	ady = (dy >= 0)? dy: -dy;
	if(dx>=0 && dy> 0) {
		if(adx < ady) dir = 0; else dir = 1; }
	else if(dx> 0 && dy<=0) {
		if(adx > ady) dir = 2; else dir = 3; }
	else if(dx<=0 && dy< 0) {
		if(adx < ady) dir = 4; else dir = 5; }
	else {
		if(adx > ady) dir = 6; else dir = 7; }
	if(adx < ady) {	i = adx; adx = ady; ady = i; }
	vw_line(dir, adx, ady); vecte();
}

grect(plane, x1, y1, x2, y2)
int	plane, x1, y1, x2, y2;
{
	int	adx, ady;

	csrw(plane, x1, y1, 0);
	adx = x2 - x1; if(adx < 0) adx = -adx;
	ady = y2 - y1; if(ady < 0) ady = -ady;
	vw_rect(0, ady, adx); vecte();
}

gcircle(plane, x, y, r)
int	plane, x, y, r;
{
	csrw(plane, x+r, y, 0); vw_circle(7, r); vecte();
	csrw(plane, x+r, y, 0); vw_circle(4, r); vecte();
	csrw(plane, x, y-r, 0); vw_circle(1, r); vecte();
	csrw(plane, x, y-r, 0); vw_circle(6, r); vecte();
	csrw(plane, x-r, y, 0); vw_circle(3, r); vecte();
	csrw(plane, x-r, y, 0); vw_circle(0, r); vecte();
	csrw(plane, x, y+r, 0); vw_circle(5, r); vecte();
	csrw(plane, x, y+r, 0); vw_circle(2, r); vecte();
}

garc(plane, x, y, r, th1, th2)
int	plane, x, y, r;
double	th1, th2;
{
	int	q, l, h, m, n, dir, xx[4], yy[4];
	double	al, bt, s, t, p, sin();
	static double c = 3.141592/180.;
	
	if(th1 > th2) th2 += 360.;
	xx[0] = x + r;	yy[0] = y;
	xx[1] = x;	yy[1] = y - r;
	xx[2] = x - r;	yy[2] = y;
	xx[3] = x;	yy[3] = y + r;
	t = 45.; p = 0.; q = 1; l = 0; dir = 4;
	while(t <= th1) {
		t += 45.; dir += 5;
		if(++q == 2) { q = 0; p += 90.; l++; }
	}
	s = th1; h = 1;
	do {
		if(t >= th2) { h = 0; t = th2; }
		if(q == 0) { al = p-t; bt = p-s; }
		else	   { al = s-p; bt = t-p; }
		m = r * sin(c*al);
		n = r * sin(c*bt);
		csrw(plane, xx[l & 3], yy[l & 3], 0);
		vw_arc(dir & 7, r, n, m); vecte();
		s = t; t += 45.; dir += 5;
		if(++q == 2) { q = 0; p += 90.; l++; }
	} while( h );
}
		
gput1(font, plane, x, y, dir, italic, zm)
int	*font, plane, x, y, dir, italic, zm;
{
	zoom( zm ); csrw(plane, x, y);
	textw( font );
	vw_char(dir, italic); texte();
}
 
command( c )
int	c;
{
	while(inp(GDCS) & 2);
	outp(GDCM, c);
}

param( p )
int	p;
{
	while(inp(GDCS) & 2);
	outp(GDCP, p);
}

select(dis, acc)
int	dis, acc;
{
	outp(0xa4, dis);
	outp(0xa6, acc);
}

c8_4096( cm )
int	cm;
{
	outp(0x6a, cm);
}

pallet( cl )
int	*cl;
{
	outp(0xa8, (cl[3]<<4) + cl[7]);
	outp(0xaa, (cl[1]<<4) + cl[5]);
	outp(0xac, (cl[2]<<4) + cl[6]);
	outp(0xae, (cl[0]<<4) + cl[4]);
}

xpallet(p, g, r, b)
int	p, g, r, b;
{
	outp(0xa8, p);
	outp(0xaa, g); outp(0xac, r); outp(0xae, b);
}

csrform( c )
int	c;
{
	command( 0x4b );
	param( c );
}

zoom( c )
{
	command( 0x46 );
	param( --c );
}

scroll(ad1, l1, ad2, l2)
unsigned	ad1, l1, ad2, l2;
{
	command( 0x70 );
	param( ad1 );	param(ad1 >> 8);
	param(l1 << 4);	param(l1  >> 4);
	param( ad2 );	param(ad2 >> 8);
	param(l2 << 4);	param(l2  >> 4);
}

write( w )
unsigned w;
{
	command( 0x20 );
	param( w );
	param(w >> 8);
}

mask( m )
int	m;
{
	command( 0x4a );
	param( m );
	param(m >> 8);
}

wt_mode( mode )
int	mode;
{
	command(0x20 + mode);	/* write */
}

vw_dot( d )
int	d;
{
	command( 0x4c ); param( 2 );
	param( d ); param(d >> 8);
}

vw_line(dir, adx, ady)
int	dir, adx, ady;
{
	int	a;
	
	command( 0x4c ); param(8 + dir);
	param( adx ); param(adx >> 8);
	ady *= 2;
	a = ady - adx;
	param( a ); param(a >> 8);
	a = ady - adx - adx;
	param( a ); param(a >> 8);
	param( ady ); param(ady >> 8);
}

vw_circle(dir, r)
int	dir, r;
{
	double	f;	int	k;
	
	command( 0x4c );
	param(0x20 + dir);
	f = r; k = f / 1.41421356 + 0.9;
	param( k ); param(k >> 8);
	k = r - 1;
	param( k ); param(k >> 8);
	k *= 2;
	param( k ); param(k >> 8);
	param( 0xff ); param( 0xff );
	param( 0 ); param( 0 );
}

vw_arc(dir, r, n, m)
int	dir, r, n, m;
{
	int	k;
	
	command( 0x4c ); param(0x20 + dir);
	param( n ); param(n >> 8);
	k = r - 1;
	param( k ); param(k >> 8);
	k *= 2;
	param( k ); param(k >> 8);
	param( 0xff ); param( 0xff );
	param( m ); param(m >> 8);
}

vw_rect(dir, a, b)
int	dir, a, b;
{
	command( 0x4c ); param(0x40 + dir);
	param( 3 ); param( 0 );
	param( a ); param(a >> 8);
	param( b ); param(b >> 8);
	param( 0xff ); param( 0xff );
	param( a ); param(a >> 8);
}

vw_char(dir, italic)
int	dir, italic;
{
	command( 0x4c );
	param((italic<<7) + 0x10 + dir);
	param( 7 ); param( 0 );
}

vw_patt(dir, italic, a, b)
int	dir, italic, a, b;
{
	command( 0x4c );
	param((italic<<7) + 0x10 + dir);
	param( b ); param(b >> 8);
	param( a ); param(a >> 8);
}

textw( tx )
int	*tx;
{
	int	i;
	
	command( 0x78 );
	for(i=0; i<8; i++) param( *tx++ );
}

lntype( type )
int	type;
{
	command( 0x78 );
	param( type ); param(type >> 8);
}

csrw(plane, x, y, wg)
int	plane, x, y, wg;
{
	int	k;
	
	k = plane + 40*y + (x >> 4);
	command( 0x49 );
	param( k ); param(k >> 8);
	param((x<<4) + 8*wg);
}

main()
{
	ginit();
	gcircle(RED, 200, 200, 50);
	gline(GREEN, 0, 0, 639, 399);
}
